<?php
wp_enqueue_style('m-style-qtip');
wp_enqueue_script('jquery-qtip');
$posts = get_posts(array('post_type' => 'page', 'posts_per_page' => -1, 'numberposts' => -1));
$types_404 = array('none' => 'None', 'wp-meta-seo-page' => __('WP Meta SEO page', 'wp-meta-seo'), 'custom_page' => __('Custom page', 'wp-meta-seo'));

$defaul_settings_404 = array('wpms_redirect_homepage' => 0, 'wpms_type_404' => 'none', 'wpms_page_redirected' => 'none');
$wpms_settings_404 = get_option('wpms_settings_404');
if (is_array($wpms_settings_404)) {
    $defaul_settings_404 = array_merge($defaul_settings_404, $wpms_settings_404);
}
?>
<div class="wrap wrap_wpms_settings">
    <h1><?php _e('WP Meta SEO global settings', 'wp-meta-seo') ?></h1>
    <div class="tab-header">
        <div class="wpms-tabs">
            <div class="wpms-tab-header active" data-label="wpms-global"><?php _e('Global', 'wp-meta-seo') ?></div>
            <div class="wpms-tab-header" data-label="wpms-redirection"><?php _e('Redirections and 404', 'wp-meta-seo') ?></div>
            <?php
                if(is_plugin_active(WPMSEO_ADDON_FILENAME)):
            ?>
            <div class="wpms-tab-header" data-label="wpms-email"><?php _e('Send Email', 'wp-meta-seo') ?></div>
            <div class="wpms-tab-header" data-label="wpms-local_usiness"><?php _e('Local business', 'wp-meta-seo') ?></div>
            <?php
                endif;
            ?>
            <div class="wpms-tab-header" data-label="wpms-jutranslation"><?php _e('Translation', 'wp-meta-seo') ?></div>
        </div>
    </div>
    <div class="wpms_content_settings">
        <div class="content-box content-wpms-global">
            <form method="post" action="options.php">
                <?php
                settings_fields('Wp Meta SEO');
                do_settings_sections('metaseo_settings');
                submit_button();
                ?>
            </form>
        </div>

        <div class="content-box content-wpms-redirection">
            <table class="form-table">
                <tbody>
                    <tr>
                        <th scope="row"><?php _e('Global home redirect', 'wp-meta-seo') ?></th>
                        <td><label>
                                <input <?php checked($defaul_settings_404['wpms_redirect_homepage'], 1) ?> data-label="wpms_redirect_homepage" type="checkbox" class="cb_option" id="wpms_redirect_homepage">
                                <?php _e('Redirect all 404 errors to home page', 'wp-meta-seo') ?>
                                <input type="hidden" class="wpms_redirect_homepage" name="wpms_redirect[wpms_redirect_homepage]" value="<?php echo $defaul_settings_404['wpms_redirect_homepage'] ?>">
                            </label>
                        </td>
                    </tr>
                    <tr>
                        <th scope="row"><?php _e('Custom 404 page', 'wp-meta-seo') ?></th>
                        <td>
                            <select name="wpms_redirect[wpms_type_404]" class="wpms_type_404" <?php echo ($defaul_settings_404['wpms_redirect_homepage'] == 1) ? "disabled" : "" ?>>
                                <?php foreach ($types_404 as $k => $type_404): ?>
                                    <option <?php selected($defaul_settings_404['wpms_type_404'], $k) ?> value="<?php echo $k ?>"><?php echo $type_404 ?></option>
                                <?php endforeach; ?>
                            </select>
                            <select name="wpms_redirect[wpms_page_redirected]" class="wpms_page_redirected" <?php echo (($defaul_settings_404['wpms_redirect_homepage'] == 1) || $defaul_settings_404['wpms_type_404'] != 'custom_page') ? "disabled" : "" ?>>
                                <option value="none"><?php _e('— Select —', 'wp-meta-seo') ?></option>
                                <?php foreach ($posts as $post): ?>
                                    <option <?php selected($defaul_settings_404['wpms_page_redirected'], $post->ID) ?> value="<?php echo $post->ID ?>"><?php echo $post->post_title ?></option>
                                <?php endforeach; ?>
                            </select>
                        </td>
                    </tr>
                </tbody>
            </table>
            <?php
            if(is_plugin_active(WPMSEO_ADDON_FILENAME)){
                echo $link_settings_html;
            }
            ?>
            <div class="button wpms_save_settings404"><?php _e('Save', 'wp-meta-seo') ?></div>
            <span class="message_saved"><?php _e('Saved', 'wp-meta-seo') ?></span>
        </div>

        <div class="content-box content-wpms-jutranslation">
            <?php echo \Joomunited\WPMetaSEO\Jutranslation\Jutranslation::getInput(); ?>
        </div>

        <?php
            if(is_plugin_active(WPMSEO_ADDON_FILENAME)){
                echo $html_tabemail;
                echo $local_business_html;
            }
        ?>

    </div>
</div>
<script type="text/javascript">
    jQuery(document).ready(function ($) {
        jQuery('.wrap_wpms_settings tr label').qtip({
            content: {
                attr: 'for'
            },
            position: {
                my: 'bottom left',
                at: 'top center'
            },
            style: {
                tip: {
                    corner: true,
                },
                classes: 'metaseo-qtip qtip-rounded'
            },
            show: 'hover',
            hide: {
                fixed: true,
                delay: 10
            }

        });

        $('.wpms-tab-header').on('click', function () {
            var $this = $(this);
            var label = $this.data('label');
            $('.wpms-tab-header').removeClass('active');
            $this.addClass('active');
            $('.content-box').addClass('content-noactive').removeClass('content-active').hide();
            $('.content-' + label + '').addClass('content-active').removeClass('content-noactive').slideDown();
        });

        $('.wpms_save_settings404').on('click', function () {
            var home_redirected = $('.wpms_redirect_homepage').val();
            var type_404 = $('.wpms_type_404').val();
            var page_redirected = $('.wpms_page_redirected').val();

            if($('#scanlinkenable').is(":checked")){
                var enable = 1;
            }else{
                var enable = 0;
            }

            $.ajax({
                url: ajaxurl,
                method: 'POST',
                dataType: 'json',
                data: {
                    'action': 'wpms_save_settings404',
                    'wpms_redirect[wpms_redirect_homepage]': home_redirected,
                    'wpms_redirect[wpms_type_404]': type_404,
                    'wpms_redirect[wpms_page_redirected]': page_redirected,
                    'enable' : enable,
                    'numberFrequency' : $('#numberFrequency').val(),
                    'showlinkFrequency' : $('#showlinkFrequency').val()
                },
                success: function (res) {
                    if (res == true) {
                        $('.message_saved').fadeIn(10).delay(2000).fadeOut(2000);
                    } else {
                        alert('Save errors !')
                    }
                }
            });
        });

        $('.wpms_save_settingemail').on('click', function () {
            if($('#showSmtpenable').is(":checked")){
                var enable = 1;
            }else{
                var enable = 0;
            }
            $this = $(this);
            $.ajax({
                url: ajaxurl,
                method: 'POST',
                dataType: 'json',
                data: {
                    action : 'wpms_save_settingemail',
                    enable : enable,
                    host : $('#showSmtpHost').val(),
                    type_encryption : $('[name="wpms_email_settings[type_encryption]"]:checked').val(),
                    port : $('#showSmtpPort').val(),
                    autentication : $('[name="wpms_email_settings[autentication]"]:checked').val(),
                    username : $('#showSmtpUser').val(),
                    password : $('#showSmtpPass').val(),
                },
                success: function (res) {
                    if (res == true) {
                        $this.closest('.content-box').find('.message_saved').fadeIn(10).delay(2000).fadeOut(2000);
                    } else {
                        alert('Save errors !')
                    }
                }
            });
        });

        $('.wpms_local_business').on('click', function () {
            if($('#local_business_enable').is(":checked")){
                var enable = 1;
            }else{
                var enable = 0;
            }
            $this = $(this);
            $.ajax({
                url: ajaxurl,
                method: 'POST',
                dataType: 'json',
                data: {
                    action : 'wpms_save_local_business',
                    enable : enable,
                    logo : $('#wpms_local_business_logo').val(),
                    country : $('#wpms_local_business_country').val(),
                    address : $('#wpms_local_business_address').val(),
                    city : $('#wpms_local_business_city').val(),
                    state : $('#wpms_local_business_state').val(),
                    phone : $('#wpms_local_business_phone').val(),
                    pricerange : $('#wpms_local_business_pricerange').val(),
                },
                success: function (res) {
                    if (res == true) {
                        $this.closest('.content-box').find('.message_saved').fadeIn(10).delay(2000).fadeOut(2000);
                    } else {
                        alert('Save errors !')
                    }
                }
            });
        });

        $(".wpms-seoImgAdd").on("click", function (e) {
            var file_frame,
                $this = $(this).parents('.wpms-seo-image-wrapper');
            if (undefined !== file_frame) {
                file_frame.open();
                return;
            }
            file_frame = wp.media.frames.file_frame = wp.media({
                title: 'Select or Upload Media For your profile gallery',
                button: {
                    text: 'Use this media'
                },
                multiple: false
            });
            file_frame.on('select', function () {
                var attachment = file_frame.state().get('selection').first().toJSON(),
                    imgId = attachment.id,
                    imgUrl = (typeof attachment.sizes.thumbnail === "undefined") ? attachment.url : attachment.sizes.thumbnail.url,
                    imgInfo = "<span><strong>URL: </strong>" + attachment.sizes.full.url + "</span>",
                    imgInfo = imgInfo + "<span><strong>Width: </strong>" + attachment.sizes.full.width + "px</span>",
                    imgInfo = imgInfo + "<span><strong>Height: </strong>" + attachment.sizes.full.height + "px</span>";
                $this.find('#wpms_local_business_logo').val(imgId);
                $this.find('.wpms-seoImgRemove').removeClass('wpms-seo-hidden');
                $this.find('img').remove();
                $this.find('.wpms-seo-image-preview').append("<img src='" + imgUrl + "' />");
                $this.parents('.wpms-seo-image').find('.image-info').html(imgInfo);
            });
            // Now display the actual file_frame
            file_frame.open();
        });

        $(".wpms-seoImgRemove").on("click", function (e) {
            e.preventDefault();
            if (confirm("Are you sure?")) {
                var $this = $(this).parents('.wpms-seo-image-wrapper');
                $this.find('input').val('');
                $this.find('.wpms-seoImgRemove').addClass('wpms-seo-hidden');
                $this.find('img').remove();
                $this.parents('.wpms-seo-image').find('.image-info').html('');
            }
        });

        $('.wpms_type_404').on('change', function () {
            var type_404 = $(this).val();
            if (type_404 == 'wp-meta-seo-page' || type_404 == 'none') {
                $('.wpms_page_redirected').prop('disabled', true);
            } else if (type_404 == 'custom_page') {
                $('.wpms_page_redirected').prop('disabled', false);
            }
        });

        $('.cb_option').unbind('click').bind('click', function () {
            var check = $(this).attr('checked');
            var type = $(this).attr('type');
            var value;
            var $this = $(this);
            if (type == 'checkbox') {
                if (check == 'checked') {
                    value = 1;
                } else {
                    value = 0;
                }
                $('input[name="wpms_redirect[' + $(this).data('label') + ']"]').val(value);

                if ($(this).data('label') == 'wpms_redirect_homepage') {
                    if (check == 'checked') {
                        $('.wpms_type_404,.wpms_page_redirected').prop('disabled', true);
                    } else {
                        $('.wpms_type_404,.wpms_page_redirected').prop('disabled', false);
                    }
                }
            }
        });
    });

</script>